



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>简单实现MySQL数据库的日志审计</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">简单实现MySQL数据库的日志审计</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-13 08:10:14 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<div>时间&nbsp;2018-12-23 08:01:11&nbsp;&nbsp;<a href="https://www.tuicool.com/sites/MNnABb" rel="external nofollow noreferrer">FreeBuf</a></div>
<div>原文&nbsp;&nbsp;<a href="https://www.freebuf.com/articles/es/192062.html?utm_source=tuicool&amp;utm_medium=referral" rel="external nofollow noreferrer">https://www.freebuf.com/articles/es/192062.html</a></div>
<div>主题&nbsp;<a href="https://www.tuicool.com/topics/11030000" rel="external nofollow noreferrer">MySQL</a></div>
</div>
<div>
<div>
<h2>0&times;0 背景</h2>
<p>由于MySQL社区版没有自带的审计功能或插件，对于等级保护当中对数据库管理的要求的就存在一定的不满足情况的，抛开条条框框不说数据库的日志是值得研究的，通过收集数据库的日志到企业SOC平台便于安全事件的溯源与故障分析，配合目前的UEBA技术能够轻松发现很多恶意事件。</p>
<p>根据等级保护内容第四章&ldquo;数据库管理系统安全技术要求&rdquo;中&nbsp;第四节&ldquo;数据库安全审计&rdquo;中明确提出数据库管理系统的安全审计应：</p>
<pre class="prettyprint linenums">1. 建立独立的安全审计系统；<br />
2. 定义与数据库安全相关的审计事件；<br />
3. 设置专门的安全审计员；<br />
4. 设置专门用于存储数据库系统审计数据的安全审计库；<br />
5. 提供适用于数据库系统的安全审计设置、分析和查阅的工具。&nbsp;
</pre>
<h2>0&times;1 部署插件</h2>
<p><strong>&nbsp;</strong>&nbsp;为了节省购买一些安全设备的费用，可以尝试使用一些开源的日志审计插件。Mysql-audit是macfee公司基于percona开发的MySQL的SQL审计插件。</p>
<p>源码地址如下：&nbsp;<a href="https://github.com/mcafee/mysql-audit" rel="external nofollow noreferrer">https://github.com/mcafee/mysql-audit</a></p>
<p>首先确定当前mysql的版本去官网下载与之相对应的插件：</p>
<p><img referrerpolicy="no-referrer"src="https://img2.tuicool.com/QZzq2yB.jpg!web" /></p>
<p><img referrerpolicy="no-referrer"src="https://img1.tuicool.com/Yb2mqqA.jpg!web" /></p>
<p>解压插件后需要确认mysql插件的安装目录：</p>
<p><img referrerpolicy="no-referrer"src="https://img0.tuicool.com/ZvuENve.jpg!web" /></p>
<p><img referrerpolicy="no-referrer"src="https://img2.tuicool.com/EVrua2z.jpg!web" /></p>
<p>将解压出来的插件libaudit_plugin.so复制到插件的目录下：</p>
<p><img referrerpolicy="no-referrer"src="https://img0.tuicool.com/aENfArY.jpg!web" /></p>
<p>使用mysql的函数install plugin导入此插件后通过show plugin确认是否导入成功。</p>
<p>主要命令如下：</p>
<pre class="prettyprint linenums">install plugin audit soname &lsquo;libaudit_plugin.so&rsquo;</pre>
<p><img referrerpolicy="no-referrer"src="https://img2.tuicool.com/bYbAjqv.jpg!web" /><img referrerpolicy="no-referrer"src="https://img0.tuicool.com/AN3Izyq.jpg!web" /></p>
<p>安装完成之后并不会立马开始审计内容，需要定义一些参数。</p>
<p>Audit_json_file这个参数要整体控制是否开启审计功能使用命令：</p>
<pre class="prettyprint linenums">Set variables audit_json_file=on</pre>
<p>开启审计功能：</p>
<p><img referrerpolicy="no-referrer"src="https://img1.tuicool.com/ZbamUvY.jpg!web" /></p>
<p>审计后的记录名可以通过查询变量audit_json_log_file获取：</p>
<pre class="prettyprint linenums">Show variables like &ldquo;audit_json_log_file&rdquo;</pre>
<p>默认的审计记录格式如下：</p>
<p><img referrerpolicy="no-referrer"src="https://img0.tuicool.com/BZJJva6.jpg!web" /></p>
<p>Json格式如下：</p>
<p><img referrerpolicy="no-referrer"src="https://img1.tuicool.com/Yj6j2eV.jpg!web" /></p>
<p>同时插件支持一些自定义的参数与命令，包括白名单与黑名单的功能。</p>
<pre class="prettyprint linenums">Audit_whitelist_users: 不审计user用户的所有命令<br />
Aduit_record_cmds: 需要进行审计的命令种类
</pre>
<p><img referrerpolicy="no-referrer"src="https://img1.tuicool.com/6Z3IzyF.jpg!web" /></p>
<p>更多的参数配置项目可以参考官方给的手册：</p>
<p><a href="https://github.com/mcafee/mysql-audit/wiki/Configuration" rel="external nofollow noreferrer">https://github.com/mcafee/mysql-audit/wiki/Configuration</a></p>
<p><img referrerpolicy="no-referrer"src="https://img1.tuicool.com/ay2mui2.jpg!web" /></p>
<h2>0&times;2 总结</h2>
<p>1. 通过插件的方式可以实现mysql日志的审计通过ELK的框架实现日志的保存与分析，再通过后期写一些脚本分析可以实现安全检测与业务分析等多个功能，关键是零成本特别适合那些&rdquo;一个人的安全部&rdquo;有此需求的同行们.</p>
<p>2. 根据一些测试数据表示，插件对性能的影响是比较大的约有20%左右的消耗需要结合具体的业务情况进行评估。</p>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r934og83.html">使用java代码关闭指定端口的程序-windows</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mvow68.html">细谈WEB标准</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd4350q.html">&amp;lt&semi;转&amp;gt&semi;两个蛋蛋的故事</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wjl7xq.html">pthread&lowbar;join和pthread&lowbar;detach的用法（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1odx19.html">mysql学习之-三种安装方式与版本介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xm52v8.html">分享个新浪下载图片的ProgressBar进度样式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok2jg19.html">02---CSS整理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjvk149.html">【排障】Outlook Express 2G收件箱大小限制</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvpy3zq.html">input 表单点击消失离开出现</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz1yvl8.html">34&period; LotusScript中的错误处理程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pd6538.html">使用angular4搭建博客（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eylkle9.html">Hadoop 实现 TF-IDF 计算</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojmrjpq.html">VB控件间的拖放</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyv3vv9.html">Session和Cookie介绍及常见httpcode</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj4le09.html">CF1105E Helping Hiasat</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r513wmq.html">&period;Net混淆工具和反混淆工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllwpoeq.html">微信小程序用setData给数组对象赋值</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5m0yeq.html">全自动数据表格JQuery版</a>
		</li>
						<li><a href="https://www.batexi.com/a/960woy49.html">cocos2d JS-&lpar;JavaScript&rpar; 函数类型相互转换&lpar;字符串、整形、浮点形、布尔值&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kkdevq.html">【Android】json格式详解</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qyye4djq.html">阿里2015校招面试回忆录（成功拿到offer）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv75o38.html">23-hadoop-hive的DDL和DML操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1xv35q.html">sshd服务防止暴力破解</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kj3nxr9.html">python get请求</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kj35069.html">WPF 数据绑定 使用Code First with Database</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxd0ezz9.html">php安装扩展模块后，重启不生效的原因及解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1ypke9.html">Servlet  监听器Listener详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv7rjy8.html">elasticsearch安装ansj分词器</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2gk3x9.html">Python爬虫框架Scrapy</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7op20e8.html">Mouse点击之后，复制GridView控件的数据行</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
